// =================================================================
// THE OFFICE DISTRICT ADVENTURE VERSION 1.0 - ONLY ONE LEVEL
// TO ADD MORE LEVELS, USE SERVER-SIDE LANGUAGE OR MODIFY THE ENGINE
// =================================================================

//Rooms, background-image, references to other rooms
//Rooms may be nativated with keyboard arrows
rooms = [
	{
		img: '1/1.png', //Main 0
		open: 1,
		top: 4,
		left: 3,
		back: 4,
		right: 1
	},
	{
		img: '1/2.png', //Office 1
		open: 1,
		left: 0,
	},
	{
		open: 1, //Shelf 2
		back: 1,
		keys: function(e) { COMP.ASCII(e.keyCode) }
	},
	{
		img: '1/3.png', //Math room 3
		open: 0,
		right: 0,
		key: 'key2'
	},
	{
		img: '1/4.png', //Library 4
		open: 0,
		top: 0,
		left: 5,
		back: 0
	},
	{
		img: '1/5.png', //Laboratory 5
		top: 6,
		open: 1,
		right: 4
	},
	{
		open: 1, //Calculator 6
		back: 5,
		keys: function(e) { CALC.key(e.keyCode) }
	},
	{
		open: 1, //Mobile 7
		back: 4
	},
	{
		key: 'key', //Game 8
		open: 0,
		back: 5,
		end: 1
	}
];

/* Thing definitions
pick  = may be picked
icon  = image visible in the pocket
text  = text displayed after you click it
click = action after you click it
useText = text after selecting item */
things = {
	f1: {pick: 1, icon: '1/fuse.png', useText: 'useFuse'},
	f2: {pick: 1, icon: '1/fuse.png', useText: 'useFuse'},
	f3: {pick: 1, icon: '1/fuse2.png', useText: 'useFuse'},
	f4: {pick: 1, icon: '1/fuse2.png', useText: 'useFuse'},

	key: {pick: 1, icon: '1/key.png', useText: 'useKey'},
	key2: {pick: 1, icon: '1/key.png', useText: 'useKey', text: 'key'},
	key3: {pick: 1, icon: '1/key.png', useText: 'useKey', text: 'key'},
	buds: {pick: 1, icon: '1/bud3.png', useText: 'useBuds'},
	card: {pick: 1, icon: '1/kart.gif', useText: 'useCard'},

	CD: {pick: 1, icon: '1/cd.png', useText: 'useCD'},
	sd: {pick: 1, icon: '1/sd.png', useText: 'useSD'},
	drawer: {click: function() { show('dropen') } },

	disk1: {pick: 1, icon: '1/disk1.png', useText: 'useDisk'},
	disk2: {pick: 1, icon: '1/disk2.png', useText: 'useDisk'},
	disk3: {pick: 1, icon: '1/disk3.png', useText: 'useDisk'},
};

//Power is disabled
AC = DC = 0;

//Connection manager
MAN = {

	//Click the LED
	LED: function()
	{
		if(AC)
		{
			say('LED')
		}
		else
		{
			say('man')
		}
	},

	//Enable LED
	turn: function(x)
	{
		//Do not blink it anymore
		if(this.which[x]) this.which[x] = 0;
		$('led'+x).className = 'LED'+x;
		this.leds[x] = 1
	},

	//Blink LED
	blink: function(x)
	{
		if(!this.inter)
		{
			this.inter = setInterval(function()
			{
				for(var i=1; i<4; i++)
				{
					if(MAN.which[i])
					{
						$('led'+i).className = (MAN.state) ? 'LED'+i : 'OFF';
						MAN.state = !MAN.state;
					}
				}
			}, 1000);
		}
		this.which[x] = 1
	},

	//Stop blinking
	stop: function(x)
	{
		this.which[x] = 0;
		if(inter && !which[1] && !which[2] && !which[3]) stopInterval(inter);
	},

	//First LED blinks until user solves CLOCK - interval object
	inter: null,
	state: 1,
	which: [0,0,0,0],

	//Status of LED
	leds: [0,0,0,0],
};

//Computer
//on: 1 POST, 2 boot, 3 wait, 4 user, 5 pass, 6 ANY, 7 printing, 8 done
COMP = {

	//Turn it on
	turn: function()
	{
		if(AC)
		{
			this.on = 1;
			this.POST()
		}
		else
		{
			say('comp')
		}
	},

	//Show startup info
	POST: function()
	{
		switch(this.on)
		{
			case 1: this.write('TODA OS 2009\n8 GB RAM\n4 GHz CPU');
				setTimeout('COMP.POST()', 3000);
				this.input = '';
				this.on = 2;
				break;

			//Detect CD
			case 2:
				if(this.drive == 2) {
					this.write('Bootable CD\nfound\nStarting CD');
					var add = function() { COMP.screen.innerHTML += '.' };
					setTimeout(add, 250);
					setTimeout(add, 500);
					setTimeout(add, 750);
					setTimeout('COMP.CDROM()', 999) }
				else {
					this.on = 3;
					this.write('ENTER\nUSERNAME');
					this.info(lang.kbd1)
				}
		}
	},

	//Show text on keyboard
	info: function(x)
	{
		this.kbdin.innerHTML = x;
	},

	//Show text on LCD
	write: function(x)
	{
		this.screen.innerHTML = (IE ? x.replace(/\n/g, '<br>') : x)
	},

	//Start CD
	CDROM: function()
	{
		if(CLOCK.on)
		{
			this.write('Rescue Code\n' + CLOCK.code + '\nDO NOT SHARE')
		}
		else
		{
			this.write('Cannot start\nC-LOCK\nSecurity System')
		}
	},
	
	//CD or DVD
	CD: function(x)
	{
		if(this.drive === x)
		{
			this.drive = 0;
			pocket.add('CD')
		}
		else if(this.on && !this.drive && thing == 'CD')
		{
			this.drive = x;
			pocket.del('CD')
		}
		else if(thing)
		{
			say( (this.on) ? 'fit' : 'tray' )
		}
		else
		{
			say( (x===1) ? 'DVD-ROM' : 'CD-ROM' )
		}
	},

	//Printer
	printer: function()
	{
		if(this.on == 8)
		{
			this.on = 9;
			find('disk1')
		}
		else if(found['f2'])
		{
			say('hole')
		}
		else
		{
			find('f2')
		}
	},

	//Print a key basing on ASCII code
	ASCII: function(x)
	{
		switch(x)
		{
			case 192: COMP.key('NOTE'); break;
			case 13: COMP.key('ENTER'); break;
			case 32: COMP.key('SPACE'); break;
			case 18: COMP.key('ANY'); break;
			case 8: COMP.key('BACKSPACE'); break;
			default: if(x > 31 && x < 94) COMP.key(String.fromCharCode(x));
		}
	},

	//Press a key
	key: function(x)
	{
		say(x);
		if(this.on > 3)
		{
			switch(x)
			{
				//Accept username and password
				case 'ENTER':
				switch(this.on)
				{
					case 4: if(this.input == OGG.name) { this.on = 5; this.info('PASSWORD') } else this.info(''); break;
					case 5: if(this.input == OGG.name.rot13()) { this.on = 6; this.info(lang.kbd3) } else this.info('');
				}
				this.input = '';
				return;

				//Press ANY key
				case 'ANY':
				if(this.on == 6)
				{
					this.on = 7;
					this.info(lang.kbd4);
					setTimeout("say('printed'); COMP.info(lang.kbd5); COMP.on = 8", 999);
					say('printed')
				}
				return;

				case 'SHIFT': break;
				case 'Mandriva Linux': say('linux'); break;
				case 'BACKSPACE': this.input = this.input.slice(0,-1); break;
				case 'SPACE': this.input += ' '; break;
				default: this.input += x;
			}
			if(this.input.length > 12)
			{
				this.input = 'LOL';
				say('reset')
			}
			this.info(this.input)
		}
		else if(x == 'NOTE' && this.on == 3)
		{
			if(OGG.on)
			{
				this.write('');
				this.info('USERNAME');
				this.on = 4;
				say('pass')
			}
			else
			{
				this.info(lang.kbd2)
			}
			this.input = ''
		}
	},

	//Diskiette
	FD: function()
	{
		say('FDD')
	},

	//Keys on the keyboard
	keys:
	[
		['NOTE', 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, '+', '=', 'BACKSPACE', 'BACKSPACE'],
		['Q','W','E','R','T','Y','U','I','O','P','[',']','ENTER','ENTER'],
		['A','S','D','F','G','H','J','K','L','','','','ENTER','ENTER'],
		['Z','X','C','V','B','N','M','.',',','?','SHIFT','SHIFT','SHIFT'],
		['SPACE', 'ANY', 'Mandriva Linux']
	],
	on: 0,
	drive: 0,
	input: '',
	kbdin: $('kbdin'),
	screen: $('LCD'),
};

//After you click the keyboard
$('kbd').onmousedown = function(e)
{
	e = e || event;
	var x = e.layerX || e.offsetX, y = e.layerY || e.offsetY, row=4, col=0, key;

	//Ctrl-Space-ANY
	if(y > 200)
	{
		row = 4;
		if(x > 135 && x < 330) col = 0;
		else if(x > 330 && x < 368) col = 1;
		else if(x > 368 && x < 400) col = 2;
	}

	//Z-M
	else if(y > 170 && x > 90 && x < 475)
	{
		row = 3;
		col = Math.floor((x-90) / 30) //30 = key width
	}

	//A-L
	else if(y > 140 && x > 77 && x < 475)
	{
		row = 2;
		col = Math.floor((x-77) / 30)
	}

	//Q-P
	else if(y > 110 && x > 70 && x < 475)
	{
		row = 1;
		col = Math.floor((x-70) / 30)
	}

	//Note + numbers
	else if(y > 80 && y < 110 && x > 25 && x < 475)
	{
		row = 0;
		col = Math.floor((x-25) / 30)
	}

	//Out of range
	else return;

	//Find a key
	if(COMP.keys[row][col])
	{
		if(e.stopPropagation) e.stopPropagation();
		COMP.key(COMP.keys[row][col]);
		return false
	}
};

//C-LOCK
CLOCK = {

	ball: function(x)
	{
		if(this.on)
		{
			switch(x)
			{
				case 1: this.input += 5; break;
				case 2: this.input -= 10; break;
				case 3: this.input *= 2; break;
				case 4: if(this.input === this.code)
				{
					this.input = 'OK';
					this.on = 0;
					MAN.turn(1);
					rooms[4].open = 1;
					say('unlock')
				}
				else this.input = 0;
			}
			if(x === this.last)
			{
				this.same++
			}
			else
			{
				this.same = 0;
				this.last = x
			}
			if(this.same > 3 || this.input > 2000)
			{
				this.input = this.o.innerHTML = 0;
				say('reset')
			}
			else
			{
				this.o.innerHTML = this.input
			}
		}
		else
		{
			say('noBall')
		}
	},

	//Start machine after it has been authorized
	start: function()
	{
		this.o.innerHTML = this.input;
		this.on = 1;
		MAN.blink(1);
		pocket.del('card')
	},

	//Display C-Lock title
	power: function()
	{
		this.o.innerHTML = 'C-LOCK™'
	},
	
	//C-LOCK state
	on: 0,

	//Last ball
	last: 0,

	//How many times was the same ball pressed?
	same: 0,

	//Current input
	input: 0,

	//Random code - min: 80 (5*16), max: 1500 (5*300)
	code: 5 * rand(16,300),

	//Input object
	o: $('code')
};

//Calculator
CALC = {

	//Enter digit
	digit: function(x) 
	{
		if(this.on && DC && this.disp.value != 'OK')
		{
			if(this.disp.value.length > 3 || this.disp.value == 'ENTER CODE')
			{
				this.disp.value = x
			}
			else
			{
				this.disp.value += x
			}
			say('button')
		}
		if(this.disp.value == arabic[number])
		{
			this.disp.value = 'OK';
			roomlist[0].put('key', 232, 264);
			say('goodNum')
		}
	},

	//Enable calc
	power: function()
	{
		if(DC && this.disks[1] == 1 && this.disks[2] == 2 && this.disks[3] == 3)
		{
			this.disp.value = 'ENTER CODE';
			this.on = 1
		}
		else
		{
			this.disp.value = '';
			this.on = 0
		}
	},

	//Insert disk
	slot: function(x, o)
	{
		if(this.on) return;
		if(this.disks[x])
		{
			pocket.add('disk' + this.disks[x]);
			o.removeAttribute('src');
			say('diskOut');
			this.disks[x] = 0
		}
		else if(thing)
		{
			switch(thing)
			{
				case 'disk1': this.disks[x] = 1; break;
				case 'disk2': this.disks[x] = 2; break;
				case 'disk3': this.disks[x] = 3; break;
				default: say('fit'); return
			}
			say('diskIn');
			o.src = things[thing].icon;
			pocket.del()
		}
		else
		{
			say('slots')
		}
		this.power()
	},

	key: function(x)
	{
		if(x>48 && x<58) this.digit(String.fromCharCode(x))
	},

	//Disk numbers
	disks: [0,0,0,0],

	//Calc enables when disks are placed properly
	on: 0,
	disp: $('disp'),
};

//Reset input value on startup
CALC.disp.value = '';

//Roman number
romans = ['MCMLXXVIII', 'MCMLXXXIX', 'MCMXVIII', 'MDCCXCI', 'MDCCLXXIII', 'CMLXVI', 'CMXCIX'];
arabic = ['1978', '1989', '1918', '1791', '1773', '966', '999'];
number = Math.floor(Math.random() * 7);
$('roman').innerHTML = romans[number];

// OGG Player
OGG = {

	//Wypełnij tekstem
	say: function(x,y,z)
	{
		$('mhead').innerHTML = x;
		$('mdesc').innerHTML = y;
		$('mbody').innerHTML = z;
	},

	//Disabled - no earphones
	on: 0,

	//Random sender = computer's login
	name: rand(['BENIAMIN','BAD BOY','BILL','TURTLE','CHRISTOPHER','RADIAN','LEO','STEFAN']),
};

//OGG onmousedown
$('mobile').onmousedown = function(e)
{
	if(thing == 'buds')
	{
		e = e || event;
		if((e.layerX || e.offsetX) < 45)
		{
			OGG.on = 1;
			OGG.say(lang.msg1, lang.msg2 + OGG.name, lang.msg3);
			pocket.del('buds');
			COMP.info(lang.kbd1);
			say('OGGPlug')
		}
		else
		{
			say('OGGSock')
		}
	}
	else
	{
		say('OGG')
	}
};

//Place a fuse
$('pin').onmousedown = function(e)
{
	switch(thing)
	{
		case 'f1': var fuse = 1; break;
		case 'f2': var fuse = 2; break;
		case 'f3': var fuse = 3; break;
		case 'f4': var fuse = 4; break;
		case '': say('pins'); return;
		default: say('fit'); return;
	}
	e = e || event;
	var x = e.layerX || e.offsetX, y = e.layerY || e.offsetY, fX, fY = 6, o;
	if(y > 20) fY = 22;
	if(x > 113) fX = 106;
	else if(x > 97) fX = 90;
	else if(x > 82) fX = 75;
	else if(x > 65) fX = 58;
	else if(x > 49) fX = 43;
	else if(x > 33) fX = 27;
	else fX = 10;

	pinX[fuse] = fX;
	pinY[fuse] = fY;

	//AC power - 2nd + 3rd and 5th + 6th
	if(!AC && pinY[1]==22 && pinY[2]==22 && ((pinX[1]==27 && pinX[2]==75) || (pinX[1]==75 && pinX[2]==27)))
	{
		things['f1'].pick = 0;
		things['f2'].pick = 0;
		AC = 1;
		MAN.turn(2);
		CLOCK.power();
		$('m2').style.color = 'green';
		say('AC')
	}

	//DC power - 3rd + 4th and 7th + 8th
	else if(!DC && pinY[3]==6 && pinY[4]==6 && ((pinX[3]==106 && pinX[4]==43) || (pinX[3]==43 && pinX[4]==106)))
	{
		things['f3'].pick = 0;
		things['f4'].pick = 0;
		DC = 1;
		MAN.turn(3);
		CALC.power();
		say('DC');

		//Insert number riddle and lock room
		var s = $('m2').parentNode.parentNode;
		s.innerHTML = '';
		s.appendChild($('orderbox'));
		rooms[0].open = 0
	}

	//Still incorrect
	else
	{
		say('fuse')
	}

	//Place the fuse
	this.put('f'+fuse, fX, fY)
};
pinX = [0,0,0,0,0];
pinY = [0,0,0,0,0];

//Order digits
$('orderbox').onmousedown = function(e)
{
	e = e || event;
	if(e.stopPropagation) e.stopPropagation();
	var td = e.srcElement || e.target;
	var tr = td.parentNode;
	var row = tr.rowIndex, cell = td.cellIndex, what, tmp, r = this.rows;

	//Do sth
	if(row == 0 || row == 4 || cell == 0 || cell == 4)
	{
		if(row == 0 && cell == 0)
		{
			tmp = r[1].cells[1].innerHTML;
			r[1].cells[1].innerHTML = r[2].cells[2].innerHTML;
			r[2].cells[2].innerHTML = r[3].cells[3].innerHTML;
			r[3].cells[3].innerHTML = tmp;
		}
		else if(row == 4 && cell == 0)
		{
			tmp = r[3].cells[1].innerHTML;
			r[3].cells[1].innerHTML = r[2].cells[2].innerHTML;
			r[2].cells[2].innerHTML = r[1].cells[3].innerHTML;
			r[1].cells[3].innerHTML = tmp;
		}
		else if(row == 0 && cell == 4)
		{
			r[4].parentNode.insertBefore(r[1], r[4])
		}
		else if(row == 4 && cell == 4)
		{
			r[1].parentNode.insertBefore(r[3], r[1])
		}
		else if(cell == 0)
		{
			tr.insertBefore(tr.cells[1], tr.cells[4])
		}
		else if(cell == 4)
		{
			tr.insertBefore(tr.cells[3], tr.cells[1])
		}
		else if(row == 0)
		{
			tmp = r[1].cells[cell].innerHTML;
			r[1].cells[cell].innerHTML = r[2].cells[cell].innerHTML;
			r[2].cells[cell].innerHTML = r[3].cells[cell].innerHTML;
			r[3].cells[cell].innerHTML = tmp;
		}
		else if(row == 4)
		{
			tmp = r[3].cells[cell].innerHTML;
			r[3].cells[cell].innerHTML = r[2].cells[cell].innerHTML;
			r[2].cells[cell].innerHTML = r[1].cells[cell].innerHTML;
			r[1].cells[cell].innerHTML = tmp;
		}
	}

	//Check if correct
	for(var i=1, cell=1, row=1, fit=0; i<10; i++)
	{
		if(r[row].cells[cell].innerHTML == i) fit++;
		if(cell > 2) { row++; cell=1 } else cell++;
	}
	if(fit > 6)
	{
		rooms[0].open = 1;
		this.parentNode.innerHTML = '¤ ¤ ¤ ¤ ¤<br><br>' + fit + ' / ' + ' 9';
		say('ordered')
	}
	return false
};

//Scan the card
function SCAN()
{
	switch(thing)
	{
		case 'card': if(AC) { CLOCK.start(); say('accept') } else say('noscan'); break;
		case 'key': case 'key2': case 'key3': say('thief'); break;
		case 'buds': say('hear'); break;
		case 'CD': say('optic'); break;
		case '': say('scan'); break;
		default: say('fit');
	}
}

//Take out the metal plate
function PLATE(o)
{
	if(thing)
	{
		if(thing == 'sd')
		{
			show(o);
			say('detach');
			pocket.del('sd');
		}
		else
		{
			say('cannot')
		}
	}
	else
	{
		say('plate')
	}
}

//Klozet
function closet(x)
{
	if(closet.open || thing == 'key3')
	{
		show('cl1');
		show('cl2');
		find('disk2');
		pocket.del('key3');
		closet.open = 1
	}
	else
	{
		say('closed')
	}
}
closet.open = 0;
closet.safe = 1;

//Preload images now
preload();

//Add white screen + finish + OGG text - Chrome does NOT see lang before onload
addEvent('load', function() {
	$('m1').innerHTML = lang.math1;
	$('m2').innerHTML = lang.math2;
	$('end').innerHTML = lang.finish;
	OGG.say(lang.locked1, lang.locked2, lang.locked3)
})